/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel  
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN    
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: st16c2550.c,v 1.4 2005/11/12 15:00:43 honda Exp $
 */

/*
 *     ST16C2550  ʰSIOɥ饤
 */

#include <sil.h>
#include "target_syssvc.h"
#include "st16c2550.h"

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U		/* ǽХå */
#define SIO_RDY_RCV	2U		/* ΥХå */

/*
 * ƥ쥸Υեå
 */
#define ST16C_RHR   0x00   /* H  LCR bit7=0 Read  */
#define ST16C_THR   0x00   /* H  LCR bit7=0 Write */
#define ST16C_DLL   0x00   /* H  LCR bit7=1       */
#define ST16C_IER   0x02   /* H  LCR bit7=0       */
#define ST16C_DLM   0x02   /* H  LCR bit7=1       */
#define ST16C_ISR   0x04   /* H  Read  */
#define ST16C_FCR   0x04   /* H  Write */
#define ST16C_LCR   0x06   /* H  */
#define ST16C_MCR   0x08   /* H  */
#define ST16C_LSR   0x0a   /* H  Read */
#define ST16C_MSR   0x0c   /* H  Read */
#define ST16C_SPR   0x0e   /* H  */

#define ISR_TX            0x02       /* ȯ */
#define IER_TX            0x02       /* ߵ */
#define ISR_RX            0x01       /* ȯ */
#define IER_RX            0x01       /* ߵ */

#define LCR_DL_MODE       0x80       /* Divisor Enable */
#define LCR_VAL           0x03       /* 8bit,1stop,Noparity,No break */
#define FCR_FIFO_DISABLE  0x00

#define LSR_RX_DATA_READY 0x01
#define LSR_TX_EMPTY      0x20

#define MCR_INT_ENABLE    0x08

/*
 *  115200bps
 *  4 = (7372800Hz)/(115200*16)
 */
#define DLM_VAL  0x00
#define DLL_VAL  0x04

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
    uint32_t reg_base;    /* 쥸Υ١ɥ쥹 */
    uint8_t  lcr_val;     /* ⡼ɥ쥸   */
    uint8_t  dlm_val;     /* ܡ졼Ⱦ̤   */
    uint8_t  dll_val;     /* ܡ졼Ȳ̤   */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
    const SIOPINIB  *p_siopinib; /* ꥢI/OݡȽ֥å */
    intptr_t         exinf;      /* ĥ */
    bool_t             openflag;   /* ץѤߥե饰 */
    bool_t             sendflag;   /* ߥ֥͡ե饰 */
    bool_t             getready;   /* ʸ */
    bool_t             putready;   /* ʸǤ */
};


/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {ST16C_CHB, LCR_VAL, DLM_VAL, DLL_VAL},
#if TNUM_SIOP > 2
    {ST16C_CHA, LCR_VAL, DLM_VAL, DLL_VAL},
#endif /* TNUM_SIOP > 2 */    
};

/*
 *  ꥢI/OݡȽ֥åμФ
 */
#define INDEX_SIOPINIB(siopid)  ((uint_t)((siopid) - 1))
#define get_siopinib(siopid)  (&(siopinib_table[INDEX_SIOPINIB(siopid)]))

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB  siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

Inline void
st16c_write(uint32_t addr, uint32_t offset, uint8_t val)
{
    sil_wrh_mem((void*)(addr + offset),val);
}

Inline uint8_t
st16c_read(uint32_t addr, uint32_t offset)
{
    return(sil_reh_mem((void*)(addr + offset)));
}

/*
 * ʸ?
 */ 
Inline bool_t
st16c_getready(SIOPCB *p_siopcb)
{
    uint16_t status;

    status = st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_LSR);
    
    return((status & LSR_RX_DATA_READY));
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
st16c_putready(SIOPCB *p_siopcb)
{
    uint16_t status;

    status = st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_LSR);
    
    return (status & LSR_TX_EMPTY);
}

/*
 *  ʸμФ
 */
Inline uint8_t
st16c_getchar(SIOPCB *p_siopcb)
{
    return(st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_RHR));
}

/*
 *  ʸν񤭹
 */
Inline void
st16c_putchar(SIOPCB *p_siopcb, uint8_t c)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_THR, c);
}

/*
 *  ߵ
 */
Inline void
st16c_enable_send(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) | IER_TX));
}

/*
 *  ߶ػ
 */
Inline void
st16c_disable_send(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) & ~IER_TX));
                
}

/*
 *  ߵ
 */
Inline void
st16c_enable_rcv(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) | IER_RX));
}

/*
 *  ߶ػ
 */
Inline void
st16c_disable_rcv(SIOPCB *p_siopcb)
{
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER,
                (st16c_read(p_siopcb->p_siopinib->reg_base, ST16C_IER) & ~IER_RX));
                
}

/*
 *  SIOɥ饤Фν롼
 */
void
st16c2550_initialize()
{
    SIOPCB  *p_siopcb;
    uint_t  i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
    
}

    
/*
 * SIOPINIBν
 */
void
st16c2550_init_siopinib(const SIOPINIB *p_siopinib)
{
    /*
     *  ʬ
     */
    /* Divisor Enable */
    st16c_write(p_siopinib->reg_base, ST16C_LCR,
                (st16c_read(p_siopinib->reg_base, ST16C_LCR) | LCR_DL_MODE));
    st16c_write(p_siopinib->reg_base, ST16C_DLL, p_siopinib->dll_val);
    st16c_write(p_siopinib->reg_base, ST16C_DLM, p_siopinib->dlm_val);
    /* Divisor Disable */
    st16c_write(p_siopinib->reg_base, ST16C_LCR,
                (st16c_read(p_siopinib->reg_base, ST16C_LCR) & ~LCR_DL_MODE));

    /* ⡼ */
    st16c_write(p_siopinib->reg_base, ST16C_LCR, p_siopinib->lcr_val);

    /* FIFO Disable */
    st16c_write(p_siopinib->reg_base, ST16C_FCR, FCR_FIFO_DISABLE);

    /* ߶ػ */
    st16c_write(p_siopinib->reg_base, ST16C_IER, 0x00);
}


/*
 *  ͥ뵯ưΥСʡѤν
 */
void
st16c2550_init(void)
{    
    st16c2550_init_siopinib(get_siopinib(1));
#if TNUM_SIOP > 2
    st16c2550_init_siopinib(get_siopinib(2));    
#endif /* TNUM_SIOP > 2 */        
    
}

/*
 * ץ󤷤ƤݡȤ뤫?
 */
bool_t
st16c2550_openflag(void)
{
#if TNUM_SIOP < 2
    return(siopcb_table[0].openflag);
#else /* TNUM_SIOP < 2 */
    return(siopcb_table[0].openflag || siopcb_table[1].openflag);
#endif /* TNUM_SIOP < 2 */
}


/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
st16c2550_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB      *p_siopcb;
    const SIOPINIB  *p_siopinib;

    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->p_siopinib;
    
    /*
     * 
     */
    st16c2550_init_siopinib(p_siopcb->p_siopinib);
    
    /* ߶ػ */
    st16c_enable_rcv(p_siopcb);
    /* ߶ػ */
    st16c_disable_rcv(p_siopcb);
    
    /* 򥤥֥͡ */
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_MCR, MCR_INT_ENABLE);

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
st16c2550_cls_por(SIOPCB *p_siopcb)
{
    /* ߶ػ */
    st16c_write(p_siopcb->p_siopinib->reg_base, ST16C_IER, 0x00);   
    p_siopcb->openflag = false;
}

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
void
st16c2550_pol_putc(char_t c, ID siopid)
{
    const SIOPINIB *p_siopinib;
    
    p_siopinib = get_siopinib(siopid);
    
    while((st16c_read(p_siopinib->reg_base, ST16C_LSR) & LSR_TX_EMPTY)
          != LSR_TX_EMPTY);
    st16c_write(p_siopinib->reg_base, ST16C_THR, c);
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
st16c2550_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (st16c_putready(p_siopcb)){
        st16c_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int
st16c2550_rcv_chr(SIOPCB *p_siopcb)
{
    if (st16c_getready(p_siopcb)) {
        return((int)(uint8_t)st16c_getchar(p_siopcb));
    }
    return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
st16c2550_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            st16c_enable_send(p_siopcb);
            break;
        case SIO_RDY_RCV:
            st16c_enable_rcv(p_siopcb);
            break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
st16c2550_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            st16c_disable_send(p_siopcb);
            break;
        case SIO_RDY_RCV:
            st16c_disable_rcv(p_siopcb);
            break;
    }
}

/*
 *  ꥢI/OݡȤФ߽
 */
static void
st16c2550_isr_siop(SIOPCB *p_siopcb)
{
    if (st16c_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        st16c2550_irdy_rcv(p_siopcb->exinf);
    }
    if (st16c_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        st16c2550_irdy_snd(p_siopcb->exinf);
    }
}

/*
 *  SIOγߥӥ롼
 */
void
st16c2550_isr(void)
{
    st16c2550_isr_siop(&(siopcb_table[0]));
}
